/******************************* Alle INCLUDE-Dateien ***********************/
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <dir.h>
#include <alloc.h>
#include <conio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <io.h>
#include <sys\stat.h>
#include <fcntl.h>
#include <graphics.h>


/******************************* Konstanten-Definition **********************/
#define MAX_PICTURE    2        /* Maximale Anzahl von Bilder verfuegbar    */

#define S_RES_MAX    256        /* Maximale Aufloesung in horizontaler Rich.*/
#define Z_RES_MAX    256        /* Maximale Aufloesung in vertikaler Richt. */
#define PIC_SIZE   65536        /* 256x256 = max. Groesse eines Bildes      */

#define POS_OFFSET   320        /* horizontaler Offset fuer das 2. Bild     */

#define GRAPH_MODE   0x2E       /* Graphik-Modus 640x480 bei 256 Farben     */
#define TEXT_MODE    0x03       /* Standard-Text-Modus 720x400 bei 16 Farben*/
#define SCREEN_SIZE   640       /* horizontale Aufloesung im Modus 0x2E     */

#define MAX_COLOR    256        /* maximale Anzahl verschiedener Farben     */

#define ROT            0
#define GRUEN          1
#define BLAU           2
#define SCHWARZ        0
#define GRAU         128
#define WEISS        255
#define CLIP_COLOR     8

#define LINE_LENGTH  131

#define TRUE           1
#define FALSE          0

#define HEADERSIZE    10

#define      INT_NO_DEFAULT    -32760   /* "unbenutzter" int-Wert   */
#define      FLOAT_NO_DEFAULT  -1e-37   /* "unbenutzter" float-Wert */

#define      _fmode   O_BINARY

#define NO_CURS_POS    0

/******************************* Konstanten-Definition **********************/
/******************************* speziell fuer HALBTON **********************/
#define QUELL_PIC      0        /* Nummer des Quellbildes                   */
#define ZIEL_PIC       1        /* Nummer des Zielbildes                    */

#define ALPHA     0.4375        /*  112/256  */
#define BETA      0.1875        /*   48/256  */
#define GAMMA     0.3125        /*   80/256  */
#define DELTA     0.0625        /*   16/256  */

#define ALEPH       1/12        /*    2/24   */
#define BET          1/3        /*    8/24   */

#define ESC           27        /* Escape          */
#define FF            12        /* Form-Feed       */
#define CR            10        /* Carriage-Return */

#define DIN_A4_H    8.27        /* Breite DIN-A4-Blatt in Inch              */
#define DIN_A4_V   11.69        /* Hoehe DIN-A4-Blatt in Inch               */

/******************************* Variablen-Definition ***********************/
typedef struct                   /* Struktur fuer die RBG-Farbanteile       */
{
  unsigned char Rot, Gruen, Blau;
} rgb;

typedef struct                       /* Daten zu den einzelnen Bildern      */
{
  int           Zeilen;              /* Aufloesung vertikal      */
  int           Spalten;             /* Aufloesung horizontal    */
} BildInfo;


#if !defined(MAIN)

extern union  REGS  pc_cpu;          /* Strukturen zur Verwend. der CPU-Reg.*/
extern struct SREGS s_cpu;

extern unsigned char far *vgaram;   /* Far-Pointer fuer den VGA-Bildschirm  */

extern unsigned char huge *Pictures;/* Huge-Pointer auf MAX_PICTURE Bilder  */

extern BildInfo  Bild[MAX_PICTURE];

#endif
