/*****************************************************************************
*                                                                            *
* void      Error_Diff(int Grautoene, int Nachbarn)                          *
*                                                                            *
******************************************************************************
*                                                                            *
* Erzeugt ein (Binaer-) Bild mit 2, 5, oder 10 Graustufen nach dem Error-    *
* Diffusions-Verfahren. Der Fehler wird auf 4, 6 oder 12 Nachbarn verteilt.  *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 19.08.1992                                               *
* Letzte Aenderung: 21.04.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input:  Grautoene: 2, 5 oder 10                                            *
*         Nachbarn:  4, 6, oder 12                                           *
*                                                                            *
******************************************************************************
*                                                                            *
* Output:                                                                    *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: WriteText()                                                    *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Error_Diff(int Grautoene, int Nachbarn)
{
  int i, s, z, Grauwert, Klipp_Grauwert;
  int GrauTabelle[MAX_COLOR];       /* Uebersetzungstabelle fuer Graustufen */
  int FehlerZeilen[(S_RES_MAX+4)*3];/* Hilfsbild zur Fehlerverteilung       */
  int FehlerIndex;
  float Error;                      /* Berechneter Fehler beim Binaerbild   */
  int  ErrorBET, ErrorALEPH, ErrorIOTA, ErrorKAPPA;
  int  Rechts, LinksUnten, Unten, RechtsUnten, UntenUnten, RechtsRechts;
  long Index1, Index2;              /* Adresse der jeweiligen Bilder        */

  WriteText(1, 25, "Bitte etwas Geduld ...");

  Rechts      = 1;                                 /* Position der Nachbarn */
  RechtsRechts= 2;
  LinksUnten  = Bild[QUELL_PIC].Spalten + 3;
  Unten       = Bild[QUELL_PIC].Spalten + 4;
  RechtsUnten = Bild[QUELL_PIC].Spalten + 5;
  UntenUnten  = (Bild[QUELL_PIC].Spalten + 4) * 2;

  /* Erzeugen eines Hilfsbildes mit 2-Pixel-Rand zur besseren Indizierung   */
  Index1     = 0;                                   /* Adresse Originalbild */
  Index2     = PIC_SIZE;                            /* Adresse Zielbild     */
  FehlerIndex=0;
  for (z=0; z<3; z++) {
      FehlerZeilen[FehlerIndex++]=Pictures[Index1];          /* linker Rand */
      FehlerZeilen[FehlerIndex++]=Pictures[Index1];          /* linker Rand */
      for (s=0; s<Bild[QUELL_PIC].Spalten; s++)
          FehlerZeilen[FehlerIndex++]=Pictures[Index1++];
      FehlerZeilen[FehlerIndex++]=0;                        /* rechter Rand */
      FehlerZeilen[FehlerIndex++]=0;                        /* rechter Rand */
  }


  if (Grautoene==2) {                         /* Error-Diffusion mit 2 Grst.*/
     switch (Nachbarn) {
         case 4:
             Index1=2*Bild[QUELL_PIC].Spalten;
             for (z=0; z<Bild[QUELL_PIC].Zeilen; z++) {
                 FehlerIndex= 2;
                 for (s=0; s<Bild[QUELL_PIC].Spalten; s++) {
                     Grauwert = (FehlerZeilen[FehlerIndex]<GRAU) ? SCHWARZ:WEISS;

                     Pictures[Index2++] = Grauwert;/* neuer Grauwert setzen und ... */

                     Error = FehlerZeilen[FehlerIndex]-Grauwert; /* Fehler berechn. */

                     /* 4 unterschiedliche Faktoren fuer 4 verschiedene Nachbarn    */
                     /*     x  7   */
                     /*  3  5  1   */
                     FehlerZeilen[FehlerIndex+Rechts]      += (int)(Error*ALPHA);
                     FehlerZeilen[FehlerIndex+LinksUnten ] += (int)(Error*BETA);
                     FehlerZeilen[FehlerIndex+Unten      ] += (int)(Error*GAMMA);
                     FehlerZeilen[FehlerIndex+RechtsUnten] += (int)(Error*DELTA);

                     FehlerIndex++;
                 }
                 /* Hilfsbild durch Umshiften der Zeilen neu initialisieren.        */
                 FehlerIndex=0;
                 for (s=0; s<(Bild[QUELL_PIC].Spalten+4); s++)
                     FehlerZeilen[FehlerIndex]=FehlerZeilen[(FehlerIndex++)+Unten];
                 FehlerZeilen[FehlerIndex++]=Pictures[Index1];       /* linker Rand */
                 FehlerZeilen[FehlerIndex++]=Pictures[Index1];       /* linker Rand */
                 for (s=0; s<Bild[QUELL_PIC].Spalten; s++)
                     FehlerZeilen[FehlerIndex++]=Pictures[Index1++];
                 FehlerZeilen[FehlerIndex++]=0;                     /* rechter Rand */
                 FehlerZeilen[FehlerIndex++]=0;                     /* rechter Rand */
             }
             break;

         case 6:
             Index1=3*Bild[QUELL_PIC].Spalten;
             for (z=0; z<Bild[QUELL_PIC].Zeilen; z++) {
                 FehlerIndex= 2;
                 for (s=0; s<Bild[QUELL_PIC].Spalten; s++) {
                     Grauwert = (FehlerZeilen[FehlerIndex]<GRAU) ? SCHWARZ:WEISS;

                     Pictures[Index2++] = Grauwert;/* neuer Grauwert setzen und ... */

                     Error = FehlerZeilen[FehlerIndex]-Grauwert; /* Fehler berechn. */

                     ErrorBET  = (int)(Error*BET);  /* Nur zwei Gewichtungsfaktoren */
                     ErrorALEPH= (int)(Error*ALEPH);

                     FehlerZeilen[FehlerIndex+Rechts]      += ErrorBET;  /*   x 8 2 */
                     FehlerZeilen[FehlerIndex+RechtsRechts]+= ErrorALEPH;/* 2 8 2   */
                     FehlerZeilen[FehlerIndex+LinksUnten]  += ErrorALEPH;/*   2     */
                     FehlerZeilen[FehlerIndex+Unten      ] += ErrorBET;
                     FehlerZeilen[FehlerIndex+RechtsUnten] += ErrorALEPH;
                     FehlerZeilen[FehlerIndex+UntenUnten]  += ErrorALEPH;

                     FehlerIndex++;
                 }
                 /* Hilfsbild durch Umshiften der Zeilen neu initialisieren.        */
                 FehlerIndex=0;
                 for (s=0; s<(Bild[QUELL_PIC].Spalten+4); s++)
                     FehlerZeilen[FehlerIndex]=FehlerZeilen[(FehlerIndex++)+Unten];
                 for (s=0; s<(Bild[QUELL_PIC].Spalten+4); s++)
                     FehlerZeilen[FehlerIndex]=FehlerZeilen[(FehlerIndex++)+Unten];
                 FehlerZeilen[FehlerIndex++]=Pictures[Index1];       /* linker Rand */
                 FehlerZeilen[FehlerIndex++]=Pictures[Index1];       /* linker Rand */
                 for (s=0; s<Bild[QUELL_PIC].Spalten; s++)
                     FehlerZeilen[FehlerIndex++]=Pictures[Index1++];
                 FehlerZeilen[FehlerIndex++]=0;                     /* rechter Rand */
                 FehlerZeilen[FehlerIndex++]=0;                     /* rechter Rand */
             }
             break;

         case 12:
             Index1=3*Bild[QUELL_PIC].Spalten;
             for (z=0; z<Bild[QUELL_PIC].Zeilen; z++) {
                 FehlerIndex= 2;
                 for (s=0; s<Bild[QUELL_PIC].Spalten; s++) {
                     Grauwert = (FehlerZeilen[FehlerIndex]<GRAU) ? SCHWARZ:WEISS;

                     Pictures[Index2++] = Grauwert;/* neuer Grauwert setzen und ... */

                     Error = FehlerZeilen[FehlerIndex]-Grauwert; /* Fehler berechn. */

                     /* 4 unterschiedliche Faktoren fuer 12 verschiedene Nachbarn    */
                     /*       x  8  4 */
                     /* 2  4  8  4  2 */
                     /* 1  2  4  2  1 */
                     ErrorALEPH= (int)(Error*8.0/42.0);
                     ErrorBET  = (int)(Error*4.0/42.0);
                     ErrorIOTA = (int)(Error*2.0/42.0);
                     ErrorKAPPA= (int)(Error*1.0/42.0);

                     FehlerZeilen[FehlerIndex+Rechts]        += ErrorALEPH;
                     FehlerZeilen[FehlerIndex+RechtsRechts]  += ErrorBET;
                     FehlerZeilen[FehlerIndex+Unten      ]   += ErrorALEPH;
                     FehlerZeilen[FehlerIndex+LinksUnten]    += ErrorBET;
                     FehlerZeilen[FehlerIndex+LinksUnten-1]  += ErrorIOTA;
                     FehlerZeilen[FehlerIndex+RechtsUnten]   += ErrorBET;
                     FehlerZeilen[FehlerIndex+RechtsUnten+1] += ErrorIOTA;
                     FehlerZeilen[FehlerIndex+UntenUnten]    += ErrorBET;
                     FehlerZeilen[FehlerIndex+UntenUnten-1]  += ErrorIOTA;
                     FehlerZeilen[FehlerIndex+UntenUnten-2]  += ErrorKAPPA;
                     FehlerZeilen[FehlerIndex+UntenUnten+1]  += ErrorIOTA;
                     FehlerZeilen[FehlerIndex+UntenUnten+2]  += ErrorKAPPA;

                     FehlerIndex++;
                 }
                 /* Hilfsbild durch Umshiften der Zeilen neu initialisieren.        */
                 FehlerIndex=0;
                 for (s=0; s<(Bild[QUELL_PIC].Spalten+4); s++)
                     FehlerZeilen[FehlerIndex]=FehlerZeilen[(FehlerIndex++)+Unten];
                 for (s=0; s<(Bild[QUELL_PIC].Spalten+4); s++)
                     FehlerZeilen[FehlerIndex]=FehlerZeilen[(FehlerIndex++)+Unten];
                 FehlerZeilen[FehlerIndex++]=Pictures[Index1];       /* linker Rand */
                 FehlerZeilen[FehlerIndex++]=Pictures[Index1];       /* linker Rand */
                 for (s=0; s<Bild[QUELL_PIC].Spalten; s++)
                     FehlerZeilen[FehlerIndex++]=Pictures[Index1++];
                 FehlerZeilen[FehlerIndex++]=0;                     /* rechter Rand */
                 FehlerZeilen[FehlerIndex++]=0;                     /* rechter Rand */
             }

             break;
     }
  }
  else {

     /* Erzeugen der Uebersetzungs-Grauton-Tabelle fuer 5 und 10 Graustufen */
     switch (Grautoene) {
        case 5:
            for (i=0; i<MAX_COLOR; i++) {
                if      (i>200) GrauTabelle[i]=255; /* Immer oberer Wert ...*/
                else if (i>150) GrauTabelle[i]=200; /* verwenden um das  ...*/
                else if (i>100) GrauTabelle[i]=150; /* Bild aufzuhellen.    */
                else if (i> 50) GrauTabelle[i]=100;
                else            GrauTabelle[i]= 50;
            }
            break;
        case 10:
            for (i=0; i<MAX_COLOR; i++){
                if      (i>229) GrauTabelle[i]=255; /* Immer oberer Wert ...*/
                else if (i>204) GrauTabelle[i]=229; /* verwenden um das  ...*/
                else if (i>178) GrauTabelle[i]=204; /* Bild aufzuhellen.    */
                else if (i>153) GrauTabelle[i]=178;
                else if (i>127) GrauTabelle[i]=153;
                else if (i>102) GrauTabelle[i]=127;
                else if (i> 76) GrauTabelle[i]=102;
                else if (i> 51) GrauTabelle[i]= 76;
                else if (i> 25) GrauTabelle[i]= 51;
                else            GrauTabelle[i]= 25;
            }
     } /* switch */


     Index1=2*Bild[QUELL_PIC].Spalten;
     for (z=0; z<Bild[QUELL_PIC].Zeilen; z++) {
         FehlerIndex= 2;
         for (s=0; s<Bild[QUELL_PIC].Spalten; s++) {
             Grauwert = FehlerZeilen[FehlerIndex];
             /* Werte clippen, falls Grauwert ausserhalb des Bereiches      */
             Klipp_Grauwert = (Grauwert<SCHWARZ)   ? SCHWARZ:(
                              (Grauwert<MAX_COLOR) ? Grauwert:WEISS );
             Grauwert           = GrauTabelle[Klipp_Grauwert];
             Pictures[Index2++] = Grauwert;       /* neuer Grauwert und ... */

             Error = Klipp_Grauwert-Grauwert;     /* ... der Fehler berechn.*/

             /* 4 unterschiedliche Faktoren fuer 4 verschiedene Nachbarn    */
             /*     x  7   */
             /*  3  5  1   */
             FehlerZeilen[FehlerIndex+Rechts]      += (int)(Error*ALPHA);
             FehlerZeilen[FehlerIndex+LinksUnten ] += (int)(Error*BETA);
             FehlerZeilen[FehlerIndex+Unten      ] += (int)(Error*GAMMA);
             FehlerZeilen[FehlerIndex+RechtsUnten] += (int)(Error*DELTA);

             FehlerIndex++;
         }
         /* Hilfsbild durch Umshiften der Zeilen neu initialisieren.        */
         FehlerIndex=0;
         for (s=0; s<(Bild[QUELL_PIC].Spalten+4); s++)
             FehlerZeilen[FehlerIndex]=FehlerZeilen[(FehlerIndex++)+Unten];
         FehlerZeilen[FehlerIndex++]=Pictures[Index1];       /* linker Rand */
         FehlerZeilen[FehlerIndex++]=Pictures[Index1];       /* linker Rand */
         for (s=0; s<Bild[QUELL_PIC].Spalten; s++)
             FehlerZeilen[FehlerIndex++]=Pictures[Index1++];
         FehlerZeilen[FehlerIndex++]=0;                     /* rechter Rand */
         FehlerZeilen[FehlerIndex++]=0;                     /* rechter Rand */

     }
  }

  /* Dimensionen und Zuordnung des neuen (Halbton-) Bildes abspeichern      */
  Bild[ZIEL_PIC].Zeilen =Bild[QUELL_PIC].Zeilen;
  Bild[ZIEL_PIC].Spalten=Bild[QUELL_PIC].Spalten;
}
