/*****************************************************************************
*                                                                            *
* main      Halbton()                                                        *
*                                                                            *
******************************************************************************
*                                                                            *
* Liest ein PCX-Bild ein und erzeugt ein Binaerbild nach verschiedenen       *
* Halbtonverfahren                                                           *
* Schwellwert, Dithering, Dot-Diffusion, Error-Diffusion).                   *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 19.08.1992                                               *
* Letzte Aenderung: 23.03.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von:  Init_Var(), Read_PCX_Picture(), Show_Pic(), Graph_Mode(),     *
*              Text_Mode(); WriteText(), Read_Int(), Error_Diff(),           *
*              Schwellwert(), Ordered_Dith(), Dot_Diffusion(),               *
*              Create_HP_File(),
*                                                                            *
*****************************************************************************/

#define  MAIN

#include "const.h"

#include "prototyp.h"

/******************************* Variablen-Definition ***********************/
union  REGS  pc_cpu;             /* Strukturen zur Verwendung der CPU-Reg.  */
struct SREGS s_cpu;

unsigned char far *vgaram;       /* Far-Pointer fuer den VGA-Bildschirmsp.  */

unsigned char huge *Pictures;    /* Far-Pointer auf die MAX_PICTURE Bilder  */

BildInfo  Bild[MAX_PICTURE];     /* Groessenangaben etc. zu den Bildern     */


main()
{
  char Antwort;
  int Auswahl, Option;
  int Graustufen;

  /*---------------------------- Initialisierung ---------------------------*/
  Init_Var();

  /*---------------------------- Einlesen des Bildes -----------------------*/
  if (!Read_PCX_Picture(QUELL_PIC)) exit(1);     /* Abbbruch bei Lesefehler */

  /*---------------------------- Anzeigen des Bildes -----------------------*/
  Graph_Mode();                  /* Graphik-Modus einschalten bis zum Ende  */
  Set_LUT();
  Show_Pic(QUELL_PIC, 1);        /* links das Originalbild anzeigen ...     */

  /*---------------------------- Halbtonverfahren --------------------------*/
  ClearTextWindow(1,18,80,25);

  WriteText(40,18,">>> Erzeugung eines Halbtonbildes <<<");
   
  WriteText(41,20,"(1)  Error-Diffusion");
  WriteText(41,21,"(2)  Ordered Dither");
  WriteText(41,22,"(3)  Schwellwertverfahren");
  WriteText(41,23,"(4)  Dot-Diffusion");
  Auswahl=5;
  while (Auswahl>4) {
        ClearTextWindow(40,25,80,25);
        gotoxy(40,25);
        Auswahl=Read_Int("Verfahren auswaehlen (0=Ende): ", 1, ' ');
  }

  ClearTextWindow(40,18,80,25);
  Graustufen=2;
  switch (Auswahl) {
     case 1:
         /*------------------------ Error-Diffusion ------------------------*/
         WriteText(40,18,"Error-Diffusion mit:");

         WriteText(40,20,"(1)  2-Graustufen ( 4 Nachbarn)");
         WriteText(40,21,"(2)  2-Graustufen ( 6 Nachbarn)");
         WriteText(40,22,"(3)  2-Graustufen (12 Nachbarn)");
         WriteText(40,23,"(4)  5-Graustufen ( 4 Nachbarn)");
         WriteText(40,24,"(5) 10-Graustufen ( 4 Nachbarn)");
         Option=6;
         while ((Option>5) || (Option<1)) {
               ClearTextWindow(40,25,80,25);
               gotoxy(40,25);
               Option=Read_Int("Welche Option ", 5, ' ');
         }

         switch (Option) {
            case 1:                 /*  2 Graustufen; 4 Nachbarn            */
                Graustufen=2;
                Error_Diff(2, 4);
                break;
            case 2:                 /*  2 Graustufen; 6 Nachbarn            */
                Error_Diff(2, 6);
                break;
            case 3:                 /*  2 Graustufen; 12 Nachbarn           */
                Graustufen=2;
                Error_Diff(2, 12);
                break;
            case 4:                 /*  5 Graustufen; 4 Nachbarn            */
                Graustufen=5;
                Error_Diff(5, 4);
                break;
            case 5:                 /* 10 Graustufen; 4 Nachbarn            */
                Graustufen=10;
                Error_Diff(10, 4);
         }
         break;

     case 2:
         /*------------------------ Ordered Dither -------------------------*/
         WriteText(40,18,"Ordered Dither mit:");
         WriteText(40,20,"(1) 8x8-Matrix 1 (aufloesungsoptimiert)");
         WriteText(40,21,"(2) 8x8-Matrix 2 (grauwertoptimiert)");
         WriteText(40,22,"(3) 4x4-Matrix");
         Option=4;
         while ((Option>3) || (Option<1)) {
               ClearTextWindow(40,24,80,25);
               gotoxy(40,25);
               Option=Read_Int("Welche Option ", 1, ' ');
         }

         Ordered_Dith(Option);
         break;

     case 3:
         /*------------------------ Schwellwertverfahren -------------------*/
         WriteText(40,18,"Schwellwertverfahren mit:");
         WriteText(40,20,"(1)  2 Graustufen");
         WriteText(40,21,"(2)  5 Graustufen");
         WriteText(40,22,"(3) 10 Graustufen");
         Option=4;
         while ((Option>3) || (Option<1)) {
               ClearTextWindow(40,24,80,25);
               gotoxy(40,25);
               Option=Read_Int("Welche Option ", 1, ' ');
         }

         switch (Option) {
            case 1:                 /* Einfaches Binaerbild                 */
                Schwellwert(Graustufen);
                break;
            case 2:                 /* Schwellwertverfahren mit 5 Graustuf. */
                Graustufen=5;
                Schwellwert(Graustufen);
                break;
            case 3:                 /* Schwellwertverfahren mit 10 Graustuf.*/
                Graustufen=10;
                Schwellwert(Graustufen);
         }
         break;

     case 4:
         /*------------------------ Dot-Diffusion --------------------------*/
         Dot_Diffusion();

  } /* switch */

  if (Auswahl>0) {               /* dann wurde Halbtonverfahren angewandt   */
     ClearTextWindow(1,18,80,25);

     /*------------------------- Graphik-Ergebnisse anzeigen ---------------*/
     Show_Pic(ZIEL_PIC,  2);     /* ... rechts das Halbtonbild.             */
  
     /*------------------------- HP-File erzeugen? -------------------------*/
     gotoxy(1,18);
     Antwort=Upper(Read_Char("Soll ein Ausgabe-File fuer den HP-Laserjet erzeugt werden", 'J'));

     if (Antwort == 'J')
        Create_HP_File(Graustufen); /* Erzeugung eines HP-Files 75 - 300 dpi*/
  }

  Text_Mode();                   /* ... und wieder in den Textmodus zurueck */
}
/*------------------------------ Main-Ende ---------------------------------*/

void Init_Var(void)              /* Initialisierung der globalen Variablen  */
{
  long Index;

  clrscr();                      /* Bildschirm loeschen                     */

  /* Platz fuer benoetigte Bilder reservieren                               */
  Pictures=farmalloc((long) (PIC_SIZE*MAX_PICTURE));
  if (Pictures == NULL) {
     WriteText(NO_CURS_POS, NO_CURS_POS, "Bilder konnten nicht angelegt werden. Abbruch!");
     exit(1);
  }

  /* Falls zu wenig freier Hauptspeicher fuer weitere Arbeiten, Abbruch.    */
  if (farcoreleft()<2*PIC_SIZE) {
     WriteText(NO_CURS_POS, NO_CURS_POS, "Zu wenig freier Hauptspeicher. Abbruch!");
     exit(1);
  }

  /* Alle Bildpunkte aller Bilder mit Schwarz initialisieren.               */
  for (Index=0; Index<(PIC_SIZE*MAX_PICTURE); Index++) Pictures[Index]=SCHWARZ;

  for (Index=0; Index<MAX_PICTURE; Index++) { /* Bild-Strukturen initialis. */
      Bild[Index].Zeilen =0;
      Bild[Index].Spalten=0;
  }

  directvideo=FALSE;      /* erlaubt Textausgabe ueber BIOS im Graphikmodus */

}
